' VBScript to convert SOE map files to SEQ map file.
' Run this file from the folder containing the maps to be converted.
' This will overwrite all the *.map files existing in that folder.

strComputer = "."
Set objWMIService = GetObject("Winmgmts:\\" & strComputer & "\root\cimv2")
Set colItems = objWMIService.ExecQuery("Select * From Win32_DesktopMonitor")
For Each objItem in colItems
	intHorizontal = objItem.ScreenWidth
	intVertical = objItem.ScreenHeight
Next
Set objExplorer = CreateObject("InternetExplorer.Application")
objExplorer.Navigate "about:blank"
objExplorer.ToolBar = 0
objExplorer.StatusBar = 0
objExplorer.Left = (intHorizontal - 400) / 2
objExplorer.Top = (intVertical - 200) / 2
objExplorer.Width = 400
objExplorer.Height = 200
objExplorer.Visible = 1
objExplorer.Document.Title = "Map Conversion in progress ..."
objExplorer.Document.Body.InnerHTML = "Starting Map Conversion."
WScript.Sleep 2000
Call Map_Convert
objExplorer.Document.Body.InnerHTML = "Map Conversion Complete."
Wscript.Sleep 2000
objExplorer.Quit
WScript.quit

' Combines layers and converts black lines to Grey
Sub Map_Convert()

	Dim r, g, b
	Dim x
	Dim sPath

	' Defaults used for Black Lines and Labels.  Set to 0 to have ignored.
	BlackLineColor = 22
	BlackLabelColor = 64

	' Set these to something other than 0 to use for all, otherwise they are ignored
	AllLineColor = 0
	AllLabelColor = 0

	' Set to 1 for connecting map lines
	ConnectDots = 1

	Dim szColor(64)

	szColor(1) = "Black"
	szColor(2) = "DarkRed"
	szColor(3) = "Firebrick"
	szColor(4) = "Red"
	szColor(5) = "DarkGreen"
	szColor(6) = "Orange"
	szColor(7) = "DarkOrange"
	szColor(8) = "DarkOrange"
	szColor(9) = "Green"
	szColor(10) = "Chartreuse"
	szColor(11) = "Gold"
	szColor(12) = "Gold"
	szColor(13) = "Green"
	szColor(14) = "Chartreuse"
	szColor(15) = "Goldenrod"
	szColor(16) = "Yellow"
	szColor(17) = "DarkBlue"
	szColor(18) = "Magenta"
	szColor(19) = "DeepPink"
	szColor(20) = "DeepPink"
	szColor(21) = "DarkCyan"
	szColor(22) = "Grey"
	szColor(23) = "IndianRed"
	szColor(24) = "LightCoral"
	szColor(25) = "SpringGreen"
	szColor(26) = "LightGreen"
	szColor(27) = "DarkKhaki"
	szColor(28) = "Khaki"
	szColor(29) = "SpringGreen"
	szColor(30) = "PaleGreen"
	szColor(31) = "DarkOliveGreen"
	szColor(32) = "Khaki"
	szColor(33) = "MediumBlue"
	szColor(34) = "DarkViolet"
	szColor(35) = "Magenta"
	szColor(36) = "Maroon"
	szColor(37) = "RoyalBlue"
	szColor(38) = "SlateBlue"
	szColor(39) = "Orchid"
	szColor(40) = "HotPink"
	szColor(41) = "Turquoise"
	szColor(42) = "SkyBlue"
	szColor(43) = "Snow"
	szColor(44) = "LightPink"
	szColor(45) = "Cyan"
	szColor(46) = "Aquamarine"
	szColor(47) = "DarkSeaGreen"
	szColor(48) = "Beige"
	szColor(49) = "Blue"
	szColor(50) = "Purple"
	szColor(51) = "Purple"
	szColor(52) = "Magenta"
	szColor(53) = "DodgerBlue"
	szColor(54) = "SlateBlue"
	szColor(55) = "MediumPurple"
	szColor(56) = "Orchid"
	szColor(57) = "DeepSkyBlue"
	szColor(58) = "LightBlue"
	szColor(59) = "Plum"
	szColor(60) = "Cyan"
	szColor(61) = "CadetBlue"
	szColor(62) = "PaleTurquoise"
	szColor(63) = "LightCyan"
	szColor(64) = "White"
	 
	Set fso = CreateObject("Scripting.FileSystemObject")
	ForReading = 1

	sPath = MID(Wscript.ScriptFullName,1,InStrRev(Wscript.ScriptFullName,"\")-1)

	Set Folder = fso.GetFolder(sPath)
	Set MapFiles = Folder.Files
	mCount = 0
	For Each myFile in MapFiles
		sExtension = mid(myFile, inStr(myFile, "_") + 1, 5)
		if sExtension = "1.txt" then
			mCount = mCount + 1
	  		strPath = myFile.Path
	  		Set Test = fso.GetFile(strPath)
		  	If Test.Size > 0 Then
				sZone = left(Test.Name, inStr(Test.Name, "_") - 1)
				szPath = sPath & "\"
				szMapFile = szPath & sZone & ".map"
				objExplorer.Document.Body.InnerHTML = "Converting <b>" & sZone & "</b> from SOE to SEQ format."
		    		Dim fs, soemap, newmap
		    		Set fs = CreateObject("Scripting.FileSystemObject")
		    		Set newmap = fs.CreateTextFile(szMapFile, True, False)
		    		newmap.writeline (sZone & " map," & sZone & ",0,0")
				For w = 1 to 2
					sFileName = szPath & sZone & "_" & w & ".txt"
					
					If fso.FileExists(sFileName) then
						Set soemap = fs.OpenTextFile(sFileName, 1, False)
						Do While soemap.AtEndOfStream <> True
							PreText = ""
							PreText = soemap.ReadLine
							' Line Handling
							If Left(PreText, 1) = "P" Then
								NextText = Replace(PreText, " ", "")
								PostText = Right(NextText, Len(NextText) - 1)
								LastText = Replace(PostText, ",to_", ",To_")
								L = Split(LastText, ",", -1)
								If UBound(L) > -1 Then
						    			' Have split line string - 9 parameters, 0-8
						    			' Convert Color into a 1-64 index
						    			r = DoColor(CLng(L(3)))
						    			g = DoColor(CLng(L(4)))
						    			b = DoColor(CLng(L(5)))
						    			Dim sTextString
						    			sTextString = Replace(L(7), "_", " ")
						    			iColorInd = (r) + (g * 4) + (b * 16) + 1
						    			' Convert Blacks to White for labels if set
									If BlackLabelColor > 0 Then
								    		If iColorInd = 1 Then iColorInd = BlackLabelColor
									End If
								
									If Len(sTextString) > 3 Then
										If Left(sTextString,3) = "To " then iColorInd = 13
									End If
									If AllLabelColor > 0 then iColorInd = AllLabelColor
									v = s = 0
						    			v = -1 * CLng(L(0))
						    			s = -1 * CLng(L(1))
						    			MapLabelOut = "P," & sTextString & "," & szColor(iColorInd) & "," & v & "," & s
						    			newmap.writeline (MapLabelOut)
								End If
						  	End If
					  		If Left(PreText, 1) = "L" Then
								PostText = Replace(PreText, "L", "")
								LastText = Replace(PostText, " ", "")
								L = Split(LastText, ",", -1)
								If UBound(L) > -1 Then
									' Have split line string - 9 parameters, 0-8
									' Convert Color into a 1-64 index
									r = DoColor(CLng(L(6)))
									g = DoColor(CLng(L(7)))
						    			b = DoColor(CLng(L(8)))
							    		iColorInd = (r) + (g * 4) + (b * 16) + 1
						    			' Convert Blacks to Grey if set
									If BlackLineColor > 0 Then
							    			If iColorInd = 1 Then iColorInd = BlackLineColor
									End If
									If AllLineColor > 0 then iColorInd = AllLineColor
									x1 = y1 = z1 = x2 = y2 = z2 = 0
						    			x1 = -1 * CLng(L(0))
						    			y1 = -1 * CLng(L(1))
						    			z1 = 10 * CLng(L(2))
						    			x2 = -1 * CLng(L(3))
						    			y2 = -1 * CLng(L(4))
						    			z2 = 10 * CLng(L(5))
						    			maplineout = "M,line," & szColor(iColorInd) & ",2," & x1 & "," & y1 & "," & z1 & "," & x2 & "," & y2 & "," & z2
						    			newmap.writeline (maplineout)
								End If
					 	 	End If
				    		Loop
						soemap.Close
					End If
				Next
				newmap.Close
				If ConnectDots = 1 Then
					objExplorer.Document.Body.InnerHTML = "Converting <b>" & sZone & "</b> from SOE to SEQ format.<br>Connecting map lines."
		  			Connect_The_Dots (szMapFile)
				End If
			End If
		End If
	Next
	if mCount = 0 then
		objExplorer.Document.Body.InnerHTML = "No Maps Found to Process.  " _
			& "Run this file from the folder containing maps."
		WScript.Sleep 5000
	End If
End Sub

Function DoColor(iColor)
	If iColor < 69 Then
		DoColor = 0
	Else
		If iColor < 160 Then
			DoColor = 1
		Else
			If iColor < 240 Then
				DoColor = 2
			Else
		    		DoColor = 3
			End If
		End If
	End If
End Function

Sub Connect_The_Dots(FileName)
	Dim Outline, PreText, NextLine
	Dim fso
	
	' Set these for connecting lines.  If it is less than this between points, it is considered equivalent
	xyCoord = 1
	zCoord = 1
	Set fso = CreateObject("Scripting.FileSystemObject")
	sBackup = FileName & "~"
	sMapFile = FileName
	optsnum = 1
	lastchance = 0
	Do While optsnum > 0
		Set MyFile = fso.GetFile(FileName)
		MyFile.Copy(sBackup)
		optsnum = 0
		Dim fs, oldmap, newmap
		Set fs = CreateObject("Scripting.FileSystemObject")
		' Create New Map for Writing Optimized Map
		Set newmap = fs.CreateTextFile(sMapFile, True, False)
		' Open map for reading (backup file)
		Set oldmap = fs.OpenTextFile(sBackup, 1, False)
		If lastchance = 1 Then
			Do
				If oldmap.AtEndOfStream <> True Then
					PreText = ""
					PreText = oldmap.ReadLine
					newmap.writeline PreText
				Else
					Exit Do
				End If
			Loop Until Left(PreText,1) = "M"
		End If
		Do While oldmap.AtEndOfStream <> True
			PreText = ""
			PreText = oldmap.ReadLine
			' Only do lines
			If Left(PreText, 1) = "M" Then
				x1 = y1 = z1 = x2 = y2 = z2 = nx1 = ny1 = nz1 = nx2 = ny2 = nz2 = 0
				L = Split(PreText, ",", -1)
				'Find number of coordinates in line
				num = (UBound(L) - 3) / 3
				pColor = L(2)
				x1 = CLng(L(4))
				y1 = CLng(L(5))
				z1 = CLng(L(6))
				x2 = CLng(L(num * 3 + 1))
				y2 = CLng(L(num * 3 + 2))
				z2 = CLng(L(num * 3 + 3))
				If oldmap.AtEndOfStream = True Then
					' At end of file, so write line and be done
					newmap.writeline PreText
			  	Else
					' Read next line, see if can add coordinates
					NextLine = oldmap.ReadLine
					If Left(NextLine, 1) = "M" Then
						M = Split(NextLine, ",", -1)
						nnum = (UBound(M) - 3) / 3
						nColor = L(2)
						nx1 = CLng(M(4))
						ny1 = CLng(M(5))
						nz1 = CLng(M(6))
						nx2 = CLng(M(nnum * 3 + 1))
						ny2 = CLng(M(nnum * 3 + 2))
						nz2 = CLng(M(nnum * 3 + 3))
						If (pColor = nColor) And (Abs(nx2 - x1) <= xyCoord) And (Abs(ny2 - y1) <= xyCoord) And (Abs(nz2 - z1) <= zCoord) Then
							optsnum = optsnum + 1
							'put 2nd point before first
							Outline = L(0) & "," & L(1) & "," & L(2) & "," & (num + nnum - 1)
							For tl = 1 To nnum
								Outline = Outline & "," & M(tl * 3 + 1) & "," & M(tl * 3 + 2) & "," & M(tl * 3 + 3)
							Next
							For tl = 2 To num
								Outline = Outline & "," & L(tl * 3 + 1) & "," & L(tl * 3 + 2) & "," & L(tl * 3 + 3)
							Next
							newmap.writeline Outline
						Else
							If (pColor = nColor) And (Abs(nx1 - x2) <= xyCoord) And (Abs(ny1 - y2) <= xyCoord) And (Abs(nz1 - z2) <= zCoord) Then
								optsnum = optsnum + 1
								' put 2nd point after first
								Outline = L(0) & "," & L(1) & "," & L(2) & "," & (num + nnum - 1)
								For tl = 1 To num
						    			Outline = Outline & "," & L(tl * 3 + 1) & "," & L(tl * 3 + 2) & "," & L(tl * 3 + 3)
								Next
								For tl = 2 To nnum
									Outline = Outline & "," & M(tl * 3 + 1) & "," & M(tl * 3 + 2) & "," & M(tl * 3 + 3)
								Next
								newmap.writeline Outline
					  		Else
								'   check lines back to back
								If (pColor = nColor) And (Abs(nx1 - x1) <= xyCoord) And (Abs(ny1 - y1) <= xyCoord) And (Abs(nz1 - z1) <= zCoord) Then
						    			optsnum = optsnum + 1
						    			' put 2nd point after first
						    			Outline = L(0) & "," & L(1) & "," & L(2) & "," & (num + nnum - 1)
									For tl = nnum To 1 Step -1
										Outline = Outline & "," & M(tl * 3 + 1) & "," & M(tl * 3 + 2) & "," & M(tl * 3 + 3)
									Next
									For tl = 2 To num
										Outline = Outline & "," & L(tl * 3 + 1) & "," & L(tl * 3 + 2) & "," & L(tl * 3 + 3)
									Next
									newmap.writeline Outline
								Else
									If (pColor = nColor) And (Abs(nx2 - x2) <= xyCoord) And (Abs(ny2 - y2) <= xyCoord) And (Abs(nz2 - z2) <= zCoord) Then
										optsnum = optsnum + 1
										' put 2nd point after first
										Outline = L(0) & "," & L(1) & "," & L(2) & "," & (num + nnum - 1)
										For tl = 1 To num
											Outline = Outline & "," & L(tl * 3 + 1) & "," & L(tl * 3 + 2) & "," & L(tl * 3 + 3)
										Next
										For tl = (nnum - 1) To 1 Step -1
											Outline = Outline & "," & M(tl * 3 + 1) & "," & M(tl * 3 + 2) & "," & M(tl * 3 + 3)
										Next
										newmap.writeline Outline
									Else
										newmap.writeline PreText
										newmap.writeline NextLine
									End If
								End If
							End If
						End If
					Else
						newmap.writeline PreText
						newmap.writeline NextLine
					End If
				End If
			Else
				newmap.writeline PreText
			End If
		Loop
		If optsnum > 0 Then lastchance = 0
		If (optsnum = 0) and (lastchance = 0) Then
			lastchance = 1
			optsnum = 1
		End If
		newmap.Close
		oldmap.Close
	Loop
	Set MyFile = fso.GetFile(sBackup)
	MyFile.Delete
End Sub